#!/bin/bash

> spec.txt



for filename in ./SYNTECH15/*.spectra; do
    echo $filename
    sed "s/--.*/ /g" $filename |  sed "s/\/\/.*/ /g" | tr '\n\r' ' ' > tmp.txt
    egrep -o "(guarantee [^;]*;)|(gar [^;]*;)" tmp.txt > tmp2.txt
    
    cat tmp2.txt |  sed "s/guarantee / /g" | sed "s/gar / /g"  | tr -d ';'   | cut -f2 -d":" |  sed 's/^[ 	]*//' | sed 's/[[:blank:]][[:blank:]]*/ /g' |  sed 's/x(/x (/' >> spec.txt
done

for filename in ./SYNTECH17/*.spectra; do
    echo $filename
    sed "s/--.*/ /g" $filename |  sed "s/\/\/.*/ /g" | tr '\n\r' ' ' > tmp.txt
    egrep -o "(guarantee [^;]*;)|(gar [^;]*;)" tmp.txt > tmp2.txt
    
    cat tmp2.txt |  sed "s/guarantee / /g" | sed "s/gar / /g"  | tr -d ';'    | cut -f2 -d":" |  sed 's/^[ 	]*//' | sed 's/[[:blank:]][[:blank:]]*/ /g' |  sed 's/x(/x (/' >> spec.txt
done

#for filename in ./SYNTECH17/*.spectra; do
#    echo $filename
#    sed "s/--.*/ /g" $filename |  sed "s/\/\/.*/ /g" | sed "s/\n/ /g" >> $filename_1.txt
#    pcregrep -M "guarantee [^;]*(\n|.)[^;\n];" $filename_1.txt |   |  egrep ".*;" | sed "s/\n/ /g" | sed 's/^[ 	]*//' | sed 's/ + /     /g' | sed 's/\/\///g' | sed 's/;//g' >> spec.txt
#done

#for filename in ./SYNTECH17/*.spectra; do
#    echo $filename
#    grep "^[^//]" $filename  | pcregrep -M 'guarantee [^;]*(\n|.)[^;\n]*;' | grep '^[^guarantee] *'  |  egrep ".*;" | sed "s/\n/ /g" | sed 's/^[ 	]*//' | sed 's/ + /     /g' | sed 's/\/\///g' | sed 's/;//g' 
#done
#for filename in ./SYNTECH17/*.spectra; do
#    echo $filename
#    grep "^[^//]" $filename  | pcregrep -M 'guarantee [^;]*(\n|.)[^;\n]*;' | grep '^[^guarantee] *' | tr '\n' ' '  | awk -F'[;]' '{print $1; print "\n";}'   | sed 's/^[ 	]*//' | sed 's/ + /     /g'   >> spec.txt
#done

echo "Number of mission specifications"
cat spec.txt | wc -l


awk '!seen[$0]++' spec.txt > missionSpecificationExp3.txt   

echo "Number of unique mission specifications"
cat missionSpecificationExp3.txt | wc -l
