#!/bin/bash


ID="([a-z](([A-Z]|[a-z]|[0-9])*|([_]*([A-Z]|[a-z]|[0-9]))*)*)"
NUMBER="([0-9][0-9]*)"
CONSTANT="([A-Z](([A-Z]|[0-9])|(_([A-Z]|[0-9])))*)"

OPERATOR="((=)|(<=)|(>=)|(==)|(!=))"
assignement="(($ID $OPERATOR $CONSTANT)|($ID $OPERATOR $ID))"
numAss="($ID $OPERATOR $NUMBER)"
#assignement="(($ID[ ]*$OPERATOR[ ]*$CONSTANT) |  )"


POSITIVEOPERATOR="((=)|(<=)|(>=)|(==)|(!=))"
posassignement="(($ID $POSITIVEOPERATOR $CONSTANT)|($ID $POSITIVEOPERATOR $ID))"
posnumAss="($ID $POSITIVEOPERATOR $NUMBER)"

ssss
positiveExp="($posassignement|$posnumAss|\($posassignement\)|\($posnumAss\)|\($posassignement\)|$ID)"

expression="($assignement|$numAss|\($assignement\)|\($numAss\)|\($assignement\)|$ID|!$ID|!$ID|!\($ID\))"

LOP="(&|[\|])"
exp1="($expression|\($expression\))"
exp="(($exp1(($LOP $exp1)*))|(\($exp1($LOP $exp1)*\))|($exp1($LOP $exp1)*\)))|(\($exp1 ($LOP $exp1)*)))*"
fexp="($exp|(\($exp\)))"

OP="&|[\|]"
posexp1="($positiveExp|\($positiveExp\))"
posexp="($posexp1(($OP) $posexp1)*)"
posfexp="($posexp|(\($posexp\)))"

reactionimpl="(($fexp)->($fexp))"

iffinvariant="(($fexp)<->($fexp))"
#""
#instantaneousReactionPattern="(G[ ]*($expression)[ ]*->[ ]*($expression))"

instantaneousReactionPattern="(G ($reactionimpl))"
pinstantaneousReactionPattern="(G [\(]$reactionimpl[\)])"
instReact="($instantaneousReactionPattern)|($pinstantaneousReactionPattern)"


npIffPattern="(G($iffinvariant))"
pIffPattern="(G[\(]$iffinvariant[\)])"
iffPattern="($npIffPattern)|($pIffPattern)"

visitPatternA="(GF ($fexp))"
visitPatternB="(GF [\(]$fexp[\)])"
visitPattern="($visitPatternA)|($visitPatternB)"

invariantPatternA="(G ($posfexp))"
invariantPatternB="(G [\(]$posfexp[\)])"
invariantPattern="($invariantPatternA)|($invariantPatternB)"


initassignments="($fexp)"
#echo $instantaneousReactionPattern
#egrep  --color=always "$fexp" nonMatchingMissions.txt



#egrep --color=always  "$instReact" tmp.txt


echo "Total number of missions to be evaluated"
cat missionSpecificationExp3.txt | wc -l

#--------------------------
echo "Computing the missions that are using the --- iff pattern"
echo "This may take a while.."
>iffPattern.txt
egrep -x   "^$iffPattern$" missionSpecificationExp3.txt > iffPattern.txt

echo "Number of mission matching the --- iff pattern"
cat iffPattern.txt | wc -l
numIff=$(cat iffPattern.txt | wc -l)

#--------------------------
echo "Computing the missions that are using the --- instantaneous reaction pattern"
echo "This may take a while.."
>instReactPattern.txt
egrep -x   "^$instReact$" missionSpecificationExp3.txt > instReactPattern.txt

echo "Number of mission matching the --- instantaneous reaction pattern"
cat instReactPattern.txt | wc -l
numInstReact=$(cat instReactPattern.txt | wc -l)

#--------------------------
echo "Computing the missions that are using the --- visit pattern"
echo "This may take a while.."
>visitPattern.txt
egrep -x   "^$visitPattern$" missionSpecificationExp3.txt > visitPattern.txt

echo "Number of mission matching the --- visit pattern"
cat visitPattern.txt | wc -l
numVisit=$(cat visitPattern.txt | wc -l)

#--------------------------
echo "Computing the missions that are using the --- init pattern"
echo "This may take a while.."
>initAssignPattern.txt
egrep -x   "^$initassignments$" missionSpecificationExp3.txt > initAssignPattern.txt

echo "Number of mission matching the --- init pattern"
cat initAssignPattern.txt | wc -l
numInit=$(cat initAssignPattern.txt | wc -l)


#--------------------------
echo "Computing the missions that are using the --- invariant pattern"
echo "This may take a while.."
>invariantPattern.txt
egrep -x   "^$invariantPattern$" missionSpecificationExp3.txt > invariantPattern.txt

echo "Number of mission matching the --- invariant pattern"
cat invariantPattern.txt | wc -l
numInv=$(cat invariantPattern.txt | wc -l)

comm -13 <(sort iffPattern.txt) <(sort missionSpecificationExp3.txt) >remaining.txt

comm -13 <(sort instReactPattern.txt) <(sort remaining.txt) >remaining2.txt

comm -13 <(sort visitPattern.txt) <(sort remaining2.txt) >remaining.txt

comm -13 <(sort initAssignPattern.txt) <(sort remaining.txt) >remaining2.txt

comm -13 <(sort invariantPattern.txt) <(sort remaining2.txt) >nonMatchingMissions.txt



echo "Number of mission that are not matching any pattern"
cat nonMatchingMissions.txt | wc -l

echo "Total matching requirements"
total="$((0+$numIff+$numInstReact+$numVisit+$numInit+$numInv))"
echo $total